Const GraphicsX=1024,GraphicsY=768,GraphicsD=32

Graphics3D(GraphicsX,GraphicsY,GraphicsD,2)

camera=CreateCamera()
CameraClsColor camera,200,200,200
CameraRange camera,0.1,1000
camlight=CreateLight(2,camera)
MoveMouse GraphicsX/2,GraphicsY/2
Global mouselock=0
Global Font_medium=LoadFont("Im Wunderland.otf",40,1)
Global Font_small=LoadFont("Im Wunderland.otf",20,1)
SetFont Font_medium

Dim Map(100,100,1)
Dim ColorSprite(10);0-Aktuell 1-10 Presets
Global SelectedColor=2

ColorSprite(1)=createSpriteMesh()
ScaleEntity ColorSprite(1),0.1,0.1,1
PositionEntity ColorSprite(1),-4.8,3,5
EntityColor ColorSprite(1),255,255,255
EntityFX ColorSprite(1),1
EntityParent ColorSprite(1),camera
EntityPickMode ColorSprite(1),2

ColorSprite(2)=createSpriteMesh()
ScaleEntity ColorSprite(2),0.1,0.1,1
PositionEntity ColorSprite(2),-4.8,2.5,5
EntityColor ColorSprite(2),0,0,0
EntityFX ColorSprite(2),1
EntityParent ColorSprite(2),camera
EntityPickMode ColorSprite(2),2

ColorSprite(3)=createSpriteMesh()
ScaleEntity ColorSprite(3),0.1,0.1,1
PositionEntity ColorSprite(3),-4.8,2,5
EntityColor ColorSprite(3),0,255,0
EntityFX ColorSprite(3),1
EntityParent ColorSprite(3),camera
EntityPickMode ColorSprite(3),2

ColorSprite(4)=createSpriteMesh()
ScaleEntity ColorSprite(4),0.1,0.1,1
PositionEntity ColorSprite(4),-4.8,1.5,5
EntityColor ColorSprite(4),255,0,0
EntityFX ColorSprite(4),1
EntityParent ColorSprite(4),camera
EntityPickMode ColorSprite(4),2

ColorSprite(5)=createSpriteMesh()
ScaleEntity ColorSprite(5),0.1,0.1,1
PositionEntity ColorSprite(5),-4.8,1,5
EntityColor ColorSprite(5),255,255,0
EntityFX ColorSprite(5),1
EntityParent ColorSprite(5),camera
EntityPickMode ColorSprite(5),2

ColorSprite(6)=createSpriteMesh()
ScaleEntity ColorSprite(6),0.1,0.1,1
PositionEntity ColorSprite(6),-4.8,0.5,5
EntityColor ColorSprite(6),0,0,255
EntityFX ColorSprite(6),1
EntityParent ColorSprite(6),camera
EntityPickMode ColorSprite(6),2

ColorSprite(7)=createSpriteMesh()
ScaleEntity ColorSprite(7),0.1,0.1,1
PositionEntity ColorSprite(7),-4.8,0,5
EntityColor ColorSprite(7),255,0,255
EntityFX ColorSprite(7),1
EntityParent ColorSprite(7),camera
EntityPickMode ColorSprite(7),2

ColorSprite(8)=createSpriteMesh()
ScaleEntity ColorSprite(8),0.1,0.1,1
PositionEntity ColorSprite(8),-4.8,-0.5,5
EntityColor ColorSprite(8),0,255,255
EntityFX ColorSprite(8),1
EntityParent ColorSprite(8),camera
EntityPickMode ColorSprite(8),2

ColorSprite(9)=createSpriteMesh()
ScaleEntity ColorSprite(9),0.1,0.1,1
PositionEntity ColorSprite(9),-4.8,-1,5
EntityColor ColorSprite(9),255,128,0
EntityFX ColorSprite(9),1
EntityParent ColorSprite(9),camera
EntityPickMode ColorSprite(9),2

ColorSprite(10)=createSpriteMesh()
ScaleEntity ColorSprite(10),0.1,0.1,1
PositionEntity ColorSprite(10),-4.8,-1.5,5
EntityColor ColorSprite(10),128,0,255
EntityFX ColorSprite(10),1
EntityParent ColorSprite(10),camera
EntityPickMode ColorSprite(10),2

ColorSprite(0)=CreateSpriteMesh()
ScaleEntity ColorSprite(0),0.1,0.1,1
PositionEntity ColorSprite(0),-2.5,3.5,5
EntityColor ColorSprite(0),0,0,0
EntityFX ColorSprite(0),1
EntityParent ColorSprite(0),camera

SaveSprite=createSpriteMesh()
ScaleEntity SaveSprite,0.2,0.2,1
PositionEntity SaveSprite,-4.5,-3.5,5
EntityColor SaveSprite,0,0,0
EntityFX SaveSprite,1
EntityParent SaveSprite,camera
EntityPickMode SaveSprite,2

PositionEntity camera,0,0,-50

For Y=1 To 100
	For X=1 To 100
		Map(X,Y,0)=createSpriteMesh()
		PositionEntity Map(X,Y,0),X*1.1,-Y*1.1,Z
		ScaleEntity Map(x,y,0),0.5,0.5,1
		EntityFX Map(x,y,0),1
		EntityPickMode Map(x,y,0),2
		If X=1 Then
			Map(X,Y,1)=2
			EntityColor Map(x,y,0),0,0,0
		ElseIf X=100 Then
			Map(X,Y,1)=2
			EntityColor Map(x,y,0),0,0,0
		ElseIf Y=1 Then
			Map(X,Y,1)=2
			EntityColor Map(x,y,0),0,0,0
		ElseIf Y=100 Then
			Map(X,Y,1)=2
			EntityColor Map(x,y,0),0,0,0
		Else
			Map(X,Y,1)=1
			EntityColor Map(x,y,0),255,255,255
		EndIf
	Next
Next

Repeat
	entity=CameraPick(camera,MouseX(),MouseY())
	If entity<>0 Then
		If MouseDown(1) Then
			Select entity
				Case ColorSprite(1)
					SelectedColor=1
					EntityColor ColorSprite(0),255,255,255
				Case ColorSprite(2)
					SelectedColor=2
					EntityColor ColorSprite(0),0,0,0
				Case ColorSprite(3)
					SelectedColor=3
					EntityColor ColorSprite(0),0,255,0
				Case ColorSprite(4)
					SelectedColor=4
					EntityColor ColorSprite(0),255,0,0
				Case ColorSprite(5)
					SelectedColor=5
					EntityColor ColorSprite(0),255,255,0
				Case ColorSprite(6)
					SelectedColor=6
					EntityColor ColorSprite(0),0,0,255
				Case ColorSprite(7)
					SelectedColor=7
					EntityColor ColorSprite(0),255,0,255
				Case ColorSprite(8)
					SelectedColor=8
					EntityColor ColorSprite(0),0,255,255
				Case ColorSprite(9)
					SelectedColor=9
					EntityColor ColorSprite(0),255,128,0
				Case ColorSprite(10)
					SelectedColor=10
					EntityColor ColorSprite(0),128,0,255
				Case SaveSprite
					image=CreateImage(100,100)
					For Y=0 To 100
						For X=0 To 100
;							rgb = r*$10000 + g*$100 + b
							Select Map(X,Y,1)
								Case 1
									rgb=255*$10000 + 255*$100 + 255
								Case 2
									rgb=0*$10000 + 0*$100 + 0
								Case 3
									rgb=0*$10000 + 255*$100 + 0
								Case 4
									rgb=255*$10000 + 0*$100 + 0
								Case 5
									rgb=255*$10000 + 255*$100 + 0
								Case 6
									rgb=0*$10000 + 0*$100 + 255
								Case 7
									rgb=255*$10000 + 0*$100 + 255
								Case 8
									rgb=0*$10000 + 255*$100 + 255
								Case 9
									rgb=255*$10000 + 128*$100 + 0
								Case 10
									rgb=128*$10000 + 0*$100 + 255	
							End Select
							WritePixel X-1,Y-1,rgb,ImageBuffer(image)
						Next
					Next
					SaveImageAsPNG("level_created.png",image)
			End Select
			For Y=2 To 99
				For X=2 To 99
					If entity=Map(X,Y,0) Then	
						Select SelectedColor
							Case 1
								EntityColor Map(X,Y,0),255,255,255
								Map(X,Y,1)=1
							Case 2
								EntityColor Map(X,Y,0),0,0,0
								Map(X,Y,1)=2
							Case 3
								EntityColor Map(X,Y,0),0,255,0
								Map(X,Y,1)=3
							Case 4
								EntityColor Map(X,Y,0),255,0,0
								Map(X,Y,1)=4
							Case 5
								EntityColor Map(X,Y,0),255,255,0
								Map(X,Y,1)=5
							Case 6
								EntityColor Map(X,Y,0),0,0,255
								Map(X,Y,1)=6
							Case 7
								EntityColor Map(X,Y,0),255,0,255
								Map(X,Y,1)=7
							Case 8
								EntityColor Map(X,Y,0),0,255,255
								Map(X,Y,1)=8
							Case 9
								EntityColor Map(X,Y,0),255,128,0
								Map(X,Y,1)=9
							Case 10
								EntityColor Map(X,Y,0),128,0,255
								Map(X,Y,1)=10
						End Select
					EndIf
				Next
			Next
		EndIf
	EndIf
	EditorMovement(camera,1,0.3)
	If KeyHit(2) Then WFMode=1-WFMode
	If KeyHit(3) Then Stop
	If KeyHit(4) Then MouseLock=1-MouseLock
	WireFrame WFMode
	RenderWorld
;	Text 0,0,"Tris: "+TrisRendered()
	Color 255,0,0
	Text 30,5,"Ausgwhltes Tile:"
	SetFont Font_small
	Text 600,5,"W A S D - Karte bewegen"
	Text 600,25,"Shift - Karte langsamer bewegen"
	Text 600,45,"3 - MausModus umschalten"
	Text 600,65,"Mausrad - Zoom"
	SetFont Font_medium
	Text 80,GraphicsY-45,"Save to level_created.png"
	Text 40,58,"Freies Feld"
	Text 40,108,"Mauer"
	Text 40,158,"Startpunkt (max 10)"
	Text 40,210,"Ziel (max 10)"
	Text 40,262,"Wchtergrenze"
	Text 40,312,"Wchter (max 99)"
	Text 40,365,"Elektrofeld"
	Text 40,415,"Unsichtbarkeitsfeld"
	Text 40,465,"Mauernspringer"
	Text 40,515,"Feuerball"
	Flip
Until KeyDown(1)





Function Movement(camera,speedfast#=3,speedslow#=1)
	mspeedx=MouseXSpeed()
	mspeedy=MouseYSpeed()
	msensivityX#=mspeedx/2
	msensivityY#=mspeedy/2
	If mspeedy<>0 Then TurnEntity camera,msensivityy,0 ,0
	If mspeedx<>0 Then TurnEntity camera,0,-msensivityX,0
	If KeyDown(54) Or KeyDown(42) Then movespeed#=speedslow Else movespeed=speedfast
	If KeyDown(32)=True Then MoveEntity camera, movespeed, 0, 0;205
	If KeyDown(30)=True Then MoveEntity camera,-movespeed, 0, 0;203
	If KeyDown(201)=True Then MoveEntity camera, 0, movespeed, 0;201
	If KeyDown(209)=True Then MoveEntity camera, 0,-movespeed, 0;209
	If KeyDown(31)=True Then MoveEntity camera, 0, 0,-movespeed;208
	If KeyDown(17)=True Then MoveEntity camera, 0, 0, movespeed;200
	If mouselock=1 Then MoveMouse GraphicsX/2,GraphicsY/2
End Function
Function EditorMovement(camera,speedfast#=3,speedslow#=1)
	mspeedx=MouseXSpeed()
	mspeedy=MouseYSpeed()
	mspeedz=MouseZSpeed()
	msensivityX#=mspeedx/4
	msensivityY#=mspeedy/4
	msensivityZ#=mspeedz*2
	If Mouselock=1 Then
		MoveMouse GraphicsX/2,GraphicsY/2
		If mspeedy<>0 Then MoveEntity camera,0,-msensivityy,0
		If mspeedx<>0 Then MoveEntity camera,msensivityX,0,0
	EndIf
	If mspeedz<>0 Then MoveEntity camera,0,0,msensivityz
	If KeyDown(54) Or KeyDown(42) Then movespeed#=speedslow Else movespeed=speedfast
	If KeyDown(32)=True Then MoveEntity camera, movespeed, 0, 0;205;d
	If KeyDown(30)=True Then MoveEntity camera,-movespeed, 0, 0;203;a
	If KeyDown(17)=True Then MoveEntity camera, 0, movespeed, 0 ;0, movespeed;200;w
	If KeyDown(31)=True Then MoveEntity camera, 0,-movespeed, 0 ;0,-movespeed;208;s
End Function
Function CreateSpriteMesh()
	mesh=CreateMesh()
	meshsurface=CreateSurface(mesh)
	v1=AddVertex(meshsurface,-1,-1,0)
	v2=AddVertex(meshsurface,-1, 1,0)
	v3=AddVertex(meshsurface, 1,-1,0)
	v4=AddVertex(meshsurface, 1, 1,0)
	VertexTexCoords meshsurface,v1,0,0
	VertexTexCoords meshsurface,v2,0,1
	VertexTexCoords meshsurface,v3,1,0
	VertexTexCoords meshsurface,v4,1,1
	AddTriangle(meshsurface,v1,v2,v4)
	AddTriangle(meshsurface,v1,v4,v3)
	Return mesh
End Function
Function SaveImageAsPNG(filename$, image, interlace = 0)
	Local i, x, y, width, height
	Local buffer, bank
	Local c
	Local result
	
	width = ImageWidth(image)
	height = ImageHeight(image)
	buffer = ImageBuffer(image)
	
	bank = CreateBank(width * height * 3 + 1)
	
	LockBuffer buffer
	For y = 0 To height - 1
		For x = 0 To width - 1
			c = ReadPixelFast(x, y, buffer)
			c = ((c And $FF) Shl 16) Or (c And $FF00) Or ((c And $FF0000) Shr 16)

			PokeInt(bank, i, c)
			
			i = i + 3
		Next
	Next
	UnlockBuffer buffer
	
	result = SavePNGFile(filename$, bank, interlace, width, height)
	
	FreeBank(bank)
	
	Return result
End Function
;